
#include	"wfdiscio.h"

#include	<stdio.h>
#include	<rpc/rpc.h>

char	*progname;
extern	int	ah_errno;

main(ac,av)		/* css2ah -- filter for CSS format		*/
int	ac;		/*	files into  AH format			*/
char	**av;		/*	--witte	20 october 1985			*/
			/*	updated to write xdr AH format files	*/
			/*	--Ken Howard September 26, 1989		*/
{
	struct	wfdisc	**wfd_pp;
	struct	wfdisc	**readin_wfdisc_file();

	progname= av[0];
	ah_errno= 0;

	if( ac == 1 || out_is_tty() )	/* no args: print usage mesg */
	{
		fprintf(stderr,"%s: Usage:\n%s wfdisc_prefix > output_file\n",progname,progname);
		exit(1);
	}
	else			/* read cmd line */
		while(--ac)
		{
			if( (wfd_pp= readin_wfdisc_file(*++av)) == NULL )
			{
				fprintf(stderr,"%s: error reading %s.wfdisc\n",progname,*av);
				fprintf( stderr, "not converting %s.wfdisc and %s.w files to ah-format\n", progname, *av, *av );
				continue;
			}
			else
			{
				css2ah(wfd_pp,stdout);
				free( (char *)wfd_pp );
			}
		}
	exit(0);
}

#include	"../ahhead.h"

/*	css2ah
 *		converts CSS format files (written on VAX) to ah-format.
 *		FILE MUST HAVE BEEN WRITTEN ON VAX!!!!!!!!!!!
 *		First cut:  should be easily generalized to handle other header
 *			information.
 *	returns:
 *			NO RETURNS -- failure causes exit(4)
 *		--witte	23 october 1985
 */
css2ah( wfd_pp, file_out )
	struct	wfdisc	*wfd_pp[];
	FILE	*file_out;
{

	ahhed	ah_hed;
	XDR	xdr_out;
	struct	wfdisc	*wfd_p;
	FILE	*dot_w_fp;
	short	data_type;
	long	offset, n_pts;
	float	*d;
	char	*data, *buffer_sun, *buffer_vax;
	long	*b;

	char	*mkdatspace(), *calloc();
	char	*strcpy(), *strcat();
	FILE	*fopen();

	xdrstdio_create(&xdr_out, file_out, XDR_ENCODE);

	while( (wfd_p= *wfd_pp++) != NULL )	/* loop over wfdisc headers */
	{
		dot_w_fp= fopen( wfd_p->file, "r" );
		if( dot_w_fp == NULL )
		{
			fprintf( stderr, "%s: can't open %s\n", progname, wfd_p->file );
			continue;
		}

		get_null_head( &ah_hed );

/*	map xxxx.wfdisc header to ah header	*/

		etoh( &(ah_hed.record.abstime), wfd_p->time );

		strcpy( ah_hed.station.code, wfd_p->sta );
		strcpy( ah_hed.station.chan, wfd_p->chan );

		ah_hed.record.ndata= (long)wfd_p->nsamp;
		ah_hed.record.delta= 1 / (wfd_p->smprat);

	/* when the info becomes available, insert calibration information */
	/* for now, place nanometers/digital count in DS, and	*/
	/* place calibration period in A0	*/

		ah_hed.station.DS= wfd_p->calib;
		ah_hed.station.A0= wfd_p->calper;

		strcpy( ah_hed.station.stype, wfd_p->instyp );
			if(ah_hed.station.stype[0] == 'm')ah_hed.station.stype[0]='i';   /* make compatible with other ah filters */
		strcpy( ah_hed.record.rcomment, wfd_p->remark );

		ah_hed.station.slat= 0.0;
		ah_hed.station.slon= 0.0;
		ah_hed.station.elev= 0.0;
		strcpy( ah_hed.record.log, "CSS_tape;" );

/* determine data type of xxxx.w files and offset in bytes of
 * xxxx.w data.
 */
 		ah_hed.record.type= FLOAT;

 		if( strncmp( "f4", wfd_p->dattyp, 2 ) == 0 )
 			data_type= FLOAT;
		else if( strncmp( "i4", wfd_p->dattyp, 2 ) == 0 )
			data_type= 0;		/* long int */
		else
		{
			fprintf( stderr, "%s: conversion from data type %s not supported\n", progname, wfd_p->dattyp );
			fprintf( stderr, "not converting %s file to ah-format\n", wfd_p->file );
			continue;
		}

		offset= wfd_p->foff;
		if( fseek( dot_w_fp, offset, 0 ) != offset )
		{
			fprintf( stderr, "%s: offset error reading %s data\n", progname, wfd_p->file );
			fprintf( stderr, "%s: not converting %s file to ah-format\n", progname, wfd_p->file );
			continue;
		}

/* allocate space for data, read it in and convert (if necessary) */

		switch( data_type )
		{
		case 0:		/* long ints: convert to floats */
			data= mkdatspace( &ah_hed );
			if( data == NULL )
			{
				fprintf( stderr, "%s: not enough memory for conversion\n", progname );
				fprintf( stderr, "not converting %s file to ah-format\n", wfd_p->file );
				continue;
			}

			buffer_vax= calloc( (unsigned)ah_hed.record.ndata, sizeof(long) );
			if( buffer_vax == NULL )
			{
				fprintf( stderr, "%s: not enough memory for conversion\n", progname );
				fprintf( stderr, "not converting %s file to ah-format\n", wfd_p->file );
				cfree( data );
				continue;
			}
			buffer_sun= calloc( (unsigned)ah_hed.record.ndata, sizeof(long) );
			if( buffer_sun == NULL )
			{
				fprintf( stderr, "%s: not enough memory for conversion\n", progname );
				fprintf( stderr, "not converting %s file to ah-format\n", wfd_p->file );
				cfree( data );
				continue;
			}
			if( !fread( buffer_vax, sizeof(long), (int)ah_hed.record.ndata, dot_w_fp ) )
			{
				fprintf( stderr, "%s: error reading %s data\n", progname, wfd_p->file );
				fprintf( stderr, "%s: not converting %s file to ah-format\n", progname, wfd_p->file );
				cfree( buffer_sun );
				cfree( buffer_vax );
				cfree( data );
				continue;
			}
			d= (float *)data;
			b= (long *)buffer_sun;
			n_pts= ah_hed.record.ndata;
			swab(buffer_vax, buffer_sun, n_pts*sizeof(long) );
			while( n_pts-- )
				*d++ = (float)*b++;

			cfree( buffer_sun );
			cfree( buffer_vax );
			break;

		case FLOAT:		/* no conversion necessary */
			data= mkdatspace( &ah_hed );
			if( data == NULL )
			{
				fprintf( stderr, "%s: not enough memory for conversion\n", progname );
				fprintf( stderr, "not converting %s file to ah-format\n", wfd_p->file );
				continue;
			}
			if( !fread( data, sizeof(float), (int)ah_hed.record.ndata, dot_w_fp ) )
			{
				fprintf( stderr, "%s: error reading %s data\n", progname, wfd_p->file );
				fprintf( stderr, "%s: not converting %s file to ah-format\n", progname, wfd_p->file );
				cfree( data );
				continue;
			}
			break;

		}

		fclose( dot_w_fp );

		xdr_putrecord( &ah_hed, data, &xdr_out );
		if( ah_errno )
			ah_error( "xdr_putrecord: exit: file %s\n", wfd_p->file, 3 );

		cfree( data );

	}		/* back to top of loop to get next header */
	xdr_destroy(&xdr_out);
	return;
}

