#include <stdio.h>
#include "muxhead.h"
#define MAXSTA 75

/*
	this routine will read the fields from  the pdp 11/70
	header assuming it was written originally on an intel
	and rearranges bytes where necessary
	long ints have bytes in the form 1 2 3 4 
	and they should be in the   form 4 3 2 1

	regular ints need to be swapped

	characters are ok as is
	
	the data file ( ints ) is also swapped
*/

extern char template_head[];
extern char template_data[];

convert2ping(rootname, machine)
char rootname[];
char machine[];
{
	struct muxhead *header;
	struct stahead *station[75];
	FILE *fopen(), *fp_head,  *fp_out;
	long *l;
	short *i;
	int status, counter, pid;
	char header_name[20];
	char data_name[20];
	char *swapbuf;
	char *cbuf;


	strcpy(header_name, rootname);
	strcat(header_name, "D");

	strcpy(data_name, rootname);
	strcat(data_name, "d");

	/* create template header and data files
	   that will be swapped so they are readable on the sun.
	*/

	strcpy(template_head, "ping2ahD.XXXXXX");
	mktemp(template_head);

	strcpy(template_data, "ping2ahd.XXXXXX");
	mktemp(template_data);


	
	swapbuf = (char *) calloc(30, sizeof(char));

	if((fp_head = fopen(header_name, "r")) == NULL)
	{
		fprintf(stderr, "Could not open %s\n", header_name);
		exit(-1);
	}


	cbuf = (char *) calloc(1, 100);
	header = (struct muxhead *) calloc(1, sizeof(struct muxhead));


	/* read and convert fields	*/

	fread(cbuf, 2, 1, fp_head);
	rearr_int(cbuf);
	i = (short *) cbuf;
	header->nchan = *i;

	fread(cbuf, 4, 1, fp_head);
	if(!strcmp(machine, "intel")) {
		rearrange(cbuf);
		l = (long *) cbuf;
	}
	else {
		swab(cbuf, swapbuf, 4);
		l = (long *) swapbuf;
	}
	header->lrate = *l;

	fread(cbuf, 4, 1, fp_head);
	if(!strcmp(machine, "intel")) {
		rearrange(cbuf);
		l = (long *) cbuf;
	}
	else {
		swab(cbuf, swapbuf, 4);
		l = (long *) swapbuf;
	}
	header->lmin = *l;

	fread(cbuf, 4, 1, fp_head);
	if(!strcmp(machine, "intel")) {
		rearrange(cbuf);
		l = (long *) cbuf;
	}
	else {
		swab(cbuf, swapbuf, 4);
		l = (long *) swapbuf;
	}
	header->lsec = *l;

	fread(cbuf, 4, 1, fp_head);
	if(!strcmp(machine, "intel")) {
		rearrange(cbuf);
		l = (long *) cbuf;
	}
	else {
		swab(cbuf, swapbuf, 4);
		l = (long *) swapbuf;
	}
	header->length = *l;

	fread(cbuf, 2, 1, fp_head);
	rearr_int(cbuf);
	i = (short *) cbuf;
	header->tapenum = *i;

	fread(cbuf, 2, 1, fp_head);
	rearr_int(cbuf);
	i = (short *) cbuf;
	header->eventnum = *i;

	fread(cbuf, 20, 1, fp_head);
	swab(cbuf, swapbuf, 20);
	i = (short *) swapbuf;
	for(counter = 0; counter <= 9; ++counter)
	{
		header->flg[counter] = *i;
		++i;
	}
	free(swapbuf);

	fread(cbuf, 10, 1, fp_head);
	strcpy(header->xtra, cbuf);

	fread(cbuf, 80, 1, fp_head);
	strcpy(header->comment, cbuf);


	/* read and convert header station information		*/

	for(counter = 0; counter < header->nchan; counter++)
	{
		station[counter] = (struct stahead *) calloc(1, sizeof(struct stahead));

		fread(cbuf, 5, 1, fp_head);
		strcpy(station[counter]->name, cbuf);

		fread(cbuf, 1, 1, fp_head);
		station[counter]->ltr = cbuf[0];

		fread(cbuf, 2, 1, fp_head);
		rearr_int(cbuf);
		i = (short *) cbuf;
		station[counter]->lta = *i;

		fread(cbuf, 2, 1, fp_head);
		rearr_int(cbuf);
		i = (short *) cbuf;
		station[counter]->trig = *i;

		fread(cbuf, 2, 1, fp_head);
		rearr_int(cbuf);
		i = (short *) cbuf;
		station[counter]->bias = *i;

	}
	fclose(fp_head);

	/* write out swapped header to template file */
	if((fp_out = fopen(template_head, "w")) == NULL)
	{
		fprintf(stderr, "Could not open %s\n", template_head);
		exit(-1);
	}

	fwrite(header, sizeof(struct muxhead), 1, fp_out);
	for(counter = 0; counter < header->nchan; counter ++)
	{
		fwrite(station[counter], sizeof(struct stahead), 1, fp_out);
		free(station[counter]);
	}

	fclose(fp_out);
	free(cbuf);


	/* swap bytes in the data file	*/

	swap_data(data_name, header);
	free(header);
}



rearrange(cbuf)
char cbuf[];
{
	/* 	this routine will rearrange 4 bytes
		in the form 4 3 2 1 
		to the form 1 2 3 4
	*/

	char temp[4];

	temp[0] = cbuf[3];
	temp[1] = cbuf[2];
	temp[2] = cbuf[1];
	temp[3] = cbuf[0];

	cbuf[0] = temp[0];
	cbuf[1] = temp[1];
	cbuf[2] = temp[2];
	cbuf[3] = temp[3];
}

rearr_int(cbuf)
char cbuf[];
{
	/*	this routine will swap bytes in place	*/

	char temp[2];

	temp[0] = cbuf[1];
	temp[1] = cbuf[0];

	cbuf[0] = temp[0];
	cbuf[1] = temp[1];
}





swap_data(data_name, header)
/* routine to swap bytes in a data file	*/
/* one channel at a time		*/
char data_name[];
struct muxhead *header;
{
	int i;
	char *cbuf, *swapbuf;
	FILE *fopen(), *fp_data, *fp_out;


	if((fp_data = fopen(data_name, "r")) == NULL)
	{
		fprintf(stderr, "could not open data file\n");
		exit(-1);
	}

	if((fp_out  = fopen(template_data, "w")) == NULL)
	{
		fprintf(stderr, "could not create temporary data file...exiting\n");
		exit(-1);
	}

	cbuf    = (char *) calloc(header->length*2, sizeof(char));
	swapbuf = (char *) calloc(header->length*2, sizeof(char));

	/* read one channel at a time, swap bytes
	   and write to temporary template file.
	*/

	for(i = 0 ; i < header->nchan; i++)
	{
		fread(cbuf, header->length*2, sizeof(char), fp_data);
		swab(cbuf, swapbuf, header->length*2);

		fwrite(swapbuf, header->length*2, sizeof(char), fp_out);
	}
	fclose(fp_data);
	fclose(fp_out);
	free(swapbuf);
	free(cbuf);
}
