
static int mo[25] = {
	0, 0, 31, 59, 90,120,151,181,212,243,273,304,334,
	0, 31, 60, 91,121,152,182,213,244,274,305,335};
grgmin(igrega,lmina)
/*
------calculate number of minutes from midnite, dec 31, 1599
*/
int *igrega;
long *lmina;
{
	long ljulda;
	julian(igrega,&ljulda);
	ljulda -= 2305448l;
	*lmina = (1440l * ljulda) + (60 * igrega[3]) + igrega[4];

}

mingrg(igregb,lminb)
/*
------calculate gregorian date from minutes past midnite, 12,31,1599
*/
int *igregb;
long *lminb;

{
	long ljuldb;
	long iminb;

	ljuldb = *lminb / 1440l;
	iminb = *lminb - (1440l * ljuldb);
	ljuldb += 2305448l;
	gregor(igregb,&ljuldb);
	igregb[3] = iminb / 60;
	igregb[4] = iminb - (60 * igregb[3]);

}

gregor(igregc,ljuldc)
/*
------function: calculate gregorian date from julian date

------blame: carl johnson (11 july 1979)

*/

int *igregc;
long *ljuldc;
{
	int ig[5];
	long ltest;
	long left;
	long lpart;
	int leap;
	int i;

	ig[0]=( *ljuldc - 1721061l) / 365l;
	ig[1]=1;
	ig[2]=1;
	julian(ig,&ltest);
	if(ltest <= *ljuldc) goto jump110;
jump20:
	--ig[0];
	julian(ig,&ltest);
	if(ltest >  *ljuldc) goto jump20;
	goto jump210;
jump105:
	++ig[0];
	julian(ig,&ltest);
jump110:
	lpart = ltest - *ljuldc -366l;
	if(lpart < 0 ) goto jump210;
	if(lpart == 0l) goto jump120;
	if(lpart > 0l) goto jump105;
jump120:
	if(ig[0]%400 == 0) goto jump210;
	if(ig[0]%100 == 0) goto jump105;
	if(ig[0]%  4 == 0) goto jump210;
	goto jump105;
jump210:
	left= *ljuldc - ltest;
	igregc[0]=ig[0];
	leap=0;
	if(ig[0]%  4 == 0) leap=12;
	if(ig[0]%100 == 0) leap=0;
	if(ig[0]%400 == 0) leap=12;
	for(i=2; i < 13; i++){
		if(mo[i+leap] <= left) goto jump250;
		igregc[1]=i-1;
		igregc[2]=left-mo[i+leap-1]+1;
		return;
jump250:
		i = i;
	}

	igregc[1]=12;
	igregc[2]=left-mo[leap+12]+1;

}

julian(igregd,ljuld)
/*
------function: convert gregorian date to julian date

......4 year, 100 year and 400 year rules observed

......blame: carl johnson
*/

int *igregd;
long *ljuld;
{
	long l4 = 1461l;
	long l100 = 36524l;
	long l400 = 146097l;
	int iyr, imo, ida, n400, n100, n4, jyr, leap;


	iyr=igregd[0];
	imo=igregd[1];
	ida=igregd[2];
	*ljuld=0;
	jyr=iyr;
	if(jyr < 1) goto lesst1;
	jyr=jyr-1;
	*ljuld=365;
	/*.....four hundred year rule  */
	n400=jyr/400;
	*ljuld +=   n400*l400;
	jyr=jyr-400*n400;
	/*.....100 year rule  */
	n100=jyr/100;
	*ljuld +=   n100*l100;
	jyr=jyr-100*n100;
	/*.....4 year rule  */
	n4=jyr/4;
	*ljuld +=   n4*l4;
	jyr=jyr-4*n4;
	/*.....one year rule  */
	*ljuld +=   jyr*365;
lesst1:
	leap=0;
	if(iyr%4 == 0) leap=12;
	if(iyr%100 == 0) leap=0;
	if(iyr%400 == 0) leap=12;
	*ljuld +=   mo[imo+leap]+ida + 1721060l;
}
