/*      muxhead -    Structure for DEmultiplexed files.
	variable char extra[] changed to char xtra[] to avoid
		conflict with defs in ahhead.h  (rbd, 12/85)
*/

struct muxhead {
	int nchan;	/* Number of demultiplexed channels */
	long lrate;	/* Sampling rate in sample per 1000 seconds */
	long lmin;	/* Reference time for Carl's date routine (grgmin) */
	long lsec;	/* Reference second from above min in microseconds */
	long length;	/* Number of samples per channel in total record */
	int tapenum;	/* Original 11/34 tape number */
	int eventnum;	/* Event number on original tape */
	int flg[10];	/* Extra flags for expansion.  flg[0] is 0 when 
			   lsec has not been set exactly and 1 after.
			   flg[1] is 0 when data can not be squashed,
			   (it is reset to 1 when OK to squash)
			   flg[2] is number of times the file has been merged.
			   flg[3] is set to 1 if time ticks are inserted */
	char xtra[10];	/* codes for extra structures for data added later*/
	char comment[80]; /* 80 optional comment characters */
};

/* Steve -- what is flg[1] AFTER squashing ?
	Also please note I have copped flg[2].
				-- don
*/


/*  The following structure exists for every station */
struct stahead {
	char name[5];	/* Station name (4 characters and a null) */
	char ltr;	/* slipped this in since it wasn't being used */
	int lta;	/* long term average */
	int trig;	/* Station trigger  (positive for trigger on) */
	int bias;	/* DC offset */
};

struct carldate {
	int year, month, day, hour, min;
};
