#include <stdio.h>
#include <rpc/rpc.h>
#include "../ahhead.h"

char *progname="xdr2ah";	/* converts xdr ah data file to sun format */

main(argc, argv)
int argc;
char *argv[];
{
	filter(stdin, stdout);
}

filter(file_in, file_out)
FILE *file_in, *file_out;
{
	XDR xdrs;
	ahhed h;
	long i;
	char *data, *mkdatspace();
	int xdr_gethead(), xdr_getdata(), putrecord();

	xdrstdio_create(&xdrs, file_in, XDR_DECODE);

	while (xdr_gethead( &h, &xdrs ) == 1) {
		data = mkdatspace(&h);
		if(data == (char *) NULL) {
			fprintf(stderr, "%s: memory allocation error\n", progname);
			exit(-1);
		}
		if(xdr_getdata(&h, data, &xdrs) == -1) {
			fprintf(stderr, "%s: data read error\n", progname);
			exit(-1);
		}
		if(putrecord( &h, (char *) data, file_out) != 0) {
			fprintf(stderr, "%s: data write error\n", progname);
			exit(-1);
		}
		free(data);
	}
	xdr_destroy(&xdrs);
}
